package net.rumati.logging.muffero;

import java.util.Deque;
import java.util.LinkedList;
import java.util.List;
import net.rumati.logging.muffero.util.ConservativeInheritableThreadLocal;

public class NDC
{
    private static final ConservativeInheritableThreadLocal<Deque<String>> stacks = new ConservativeInheritableThreadLocal<Deque<String>>()
    {
        @Override
        protected Deque<String> create()
        {
            return new LinkedList<String>();
        }
    };

    private NDC()
    {
    }

    public static void push(String key)
    {
        stacks.get(true).push(key);
    }

    public static String pop()
    {
        Deque<String> stack = stacks.get();
        if (stack != null && !stack.isEmpty()){
            return stack.pop();
        }
        return null;
    }

    public static void pop(String key)
    {
        while (true){
            String top = pop();
            if (top == null){
                break;
            }else if (top.equals(key)){
                break;
            }
        }
    }

    public static List<String> getCopyOfStack()
    {
        List<String> retv = new LinkedList<String>();
        Deque<String> stack = stacks.get();
        if (stack != null){
            retv.addAll(stack);
        }
        return retv;
    }
}
